diff -rud fltk-1.1.x-r5224.Orig/FL/Fl_Gl_Window.H fltk-1.1.x-r5224/FL/Fl_Gl_Window.H
--- fltk-1.1.x-r5224.Orig/FL/Fl_Gl_Window.H	2006-06-28 16:39:56.000000000 +0200
+++ fltk-1.1.x-r5224/FL/Fl_Gl_Window.H	2006-06-28 16:42:59.000000000 +0200
@@ -41,6 +41,7 @@
   const int *alist;
   Fl_Gl_Choice *g;
   GLContext context_;
+  char ctx_valid_;
   char valid_;
   char damage1_; // damage() of back buffer
   virtual void draw_overlay();
@@ -61,6 +62,9 @@
   void hide();
   void resize(int,int,int,int);
 
+  char ctx_valid() const {return ctx_valid_;}
+  void ctx_valid(char v) {ctx_valid_ = v;}
+
   char valid() const {return valid_;}
   void valid(char v) {valid_ = v;}
   void invalidate();
diff -rud fltk-1.1.x-r5224.Orig/src/Fl_Gl_Window.cxx fltk-1.1.x-r5224/src/Fl_Gl_Window.cxx
--- fltk-1.1.x-r5224.Orig/src/Fl_Gl_Window.cxx	2006-06-28 16:40:00.000000000 +0200
+++ fltk-1.1.x-r5224/src/Fl_Gl_Window.cxx	2006-06-28 16:45:32.000000000 +0200
@@ -87,6 +87,7 @@
 }
 
 void Fl_Gl_Window::invalidate() {
+  ctx_valid(0);
   valid(0);
 #ifndef WIN32
   if (overlay) ((Fl_Gl_Window*)overlay)->valid(0);
@@ -160,6 +161,7 @@
   if (!context_) {
     mode_ &= ~NON_LOCAL_CONTEXT;
     context_ = fl_create_gl_context(this, g);
+    ctx_valid(0);
     valid(0);
   }
   fl_set_gl_context(this, context_);
@@ -380,6 +382,7 @@
 #if HAVE_GL_OVERLAY && defined(WIN32)
   if (fixcursor) SetCursor(Fl_X::i(this)->cursor);
 #endif
+  ctx_valid(1);
   valid(1);
 }
 
